Bullet Collision Detection & Physics Library: btMultiBodyJointMotor Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
btMultiBodyJointMotor Class Reference

`#include <btMultiBodyJointMotor.h>`

Inheritance diagram for btMultiBodyJointMotor:
[legend]
Collaboration diagram for btMultiBodyJointMotor:
[legend]

## Public Member Functions
| btMultiBodyJointMotor (btMultiBody *body, int link, btScalar desiredVelocity, btScalar maxMotorImpulse)
| This file was written by Erwin Coumans.
| btMultiBodyJointMotor (btMultiBody *body, int link, int linkDoF, btScalar desiredVelocity, btScalar maxMotorImpulse)
virtual | ~btMultiBodyJointMotor ()
virtual void | finalizeMultiDof ()
virtual int | getIslandIdA () const
virtual int | getIslandIdB () const
virtual void | createConstraintRows (btMultiBodyConstraintArray &constraintRows, btMultiBodyJacobianData &data, const btContactSolverInfo &infoGlobal)
virtual void | setVelocityTarget (btScalar velTarget, btScalar kd=1.f)
virtual void | setPositionTarget (btScalar posTarget, btScalar kp=1.f)
virtual void | setErp (btScalar erp)
virtual btScalar | getErp () const
virtual void | setRhsClamp (btScalar rhsClamp)
virtual void | debugDraw (class btIDebugDraw *drawer)
Public Member Functions inherited from btMultiBodyConstraint
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btMultiBodyConstraint (btMultiBody *bodyA, btMultiBody *bodyB, int linkA, int linkB, int numRows, bool isUnilateral, int type)
virtual | ~btMultiBodyConstraint ()
void | updateJacobianSizes ()
void | allocateJacobiansMultiDof ()
int | getConstraintType () const
virtual void | setFrameInB (const btMatrix3x3 &frameInB)
virtual void | setPivotInB (const btVector3 &pivotInB)
int | getNumRows () const
btMultiBody * | getMultiBodyA ()
btMultiBody * | getMultiBodyB ()
int | getLinkA () const
int | getLinkB () const
void | internalSetAppliedImpulse (int dof, btScalar appliedImpulse)
btScalar | getAppliedImpulse (int dof)
btScalar | getPosition (int row) const
void | setPosition (int row, btScalar pos)
bool | isUnilateral () const
btScalar * | jacobianA (int row)
const btScalar * | jacobianA (int row) const
btScalar * | jacobianB (int row)
const btScalar * | jacobianB (int row) const
btScalar | getMaxAppliedImpulse () const
void | setMaxAppliedImpulse (btScalar maxImp)
virtual void | setGearRatio (btScalar ratio)
virtual void | setGearAuxLink (int gearAuxLink)
virtual void | setRelativePositionTarget (btScalar relPosTarget)

## Protected Attributes
btScalar | m_desiredVelocity
btScalar | m_desiredPosition
btScalar | m_kd
btScalar | m_kp
btScalar | m_erp
btScalar | m_rhsClamp
Protected Attributes inherited from btMultiBodyConstraint
btMultiBody * | m_bodyA
btMultiBody * | m_bodyB
int | m_linkA
int | m_linkB
int | m_type
int | m_numRows
int | m_jacSizeA
int | m_jacSizeBoth
int | m_posOffset
bool | m_isUnilateral
int | m_numDofsFinalized
btScalar | m_maxAppliedImpulse
btAlignedObjectArray< btScalar > | m_data

## Additional Inherited Members
Protected Member Functions inherited from btMultiBodyConstraint
void | applyDeltaVee (btMultiBodyJacobianData &data, btScalar *delta_vee, btScalar impulse, int velocityIndex, int ndof)
btScalar | fillMultiBodyConstraint (btMultiBodySolverConstraint &solverConstraint, btMultiBodyJacobianData &data, btScalar *jacOrgA, btScalar *jacOrgB, const btVector3 &constraintNormalAng, const btVector3 &constraintNormalLin, const btVector3 &posAworld, const btVector3 &posBworld, btScalar posError, const btContactSolverInfo &infoGlobal, btScalar lowerLimit, btScalar upperLimit, bool angConstraint=false, btScalar relaxation=1.f, bool isFriction=false, btScalar desiredVelocity=0, btScalar cfmSlip=0, btScalar damping=1.0)

## Detailed Description

Definition at line 24 of file btMultiBodyJointMotor.h.

## Constructor & Destructor Documentation

## ◆ btMultiBodyJointMotor() [1/2]

btMultiBodyJointMotor::btMultiBodyJointMotor | ( | btMultiBody * | body,
|  | int | link,
|  | btScalar | desiredVelocity,
|  | btScalar | maxMotorImpulse )

This file was written by Erwin Coumans.

Definition at line 23 of file btMultiBodyJointMotor.cpp.

## ◆ btMultiBodyJointMotor() [2/2]

btMultiBodyJointMotor::btMultiBodyJointMotor | ( | btMultiBody * | body,
|  | int | link,
|  | int | linkDoF,
|  | btScalar | desiredVelocity,
|  | btScalar | maxMotorImpulse )

Definition at line 52 of file btMultiBodyJointMotor.cpp.

## ◆ ~btMultiBodyJointMotor()

btMultiBodyJointMotor::~btMultiBodyJointMotor | ( |  | ) |
| virtual

Definition at line 66 of file btMultiBodyJointMotor.cpp.

## Member Function Documentation

## ◆ createConstraintRows()

void btMultiBodyJointMotor::createConstraintRows | ( | btMultiBodyConstraintArray & | constraintRows,
|  | btMultiBodyJacobianData & | data,
|  | const btContactSolverInfo & | infoGlobal )
| virtual

Implements btMultiBodyConstraint.

Definition at line 106 of file btMultiBodyJointMotor.cpp.

## ◆ debugDraw()

virtual void btMultiBodyJointMotor::debugDraw | ( | class btIDebugDraw * | drawer | ) |
| inlinevirtual

Implements btMultiBodyConstraint.

Definition at line 71 of file btMultiBodyJointMotor.h.

## ◆ finalizeMultiDof()

void btMultiBodyJointMotor::finalizeMultiDof | ( |  | ) |
| virtual

Implements btMultiBodyConstraint.

Definition at line 37 of file btMultiBodyJointMotor.cpp.

## ◆ getErp()

virtual btScalar btMultiBodyJointMotor::getErp | ( |  | ) | const
| inlinevirtual

Definition at line 63 of file btMultiBodyJointMotor.h.

## ◆ getIslandIdA()

int btMultiBodyJointMotor::getIslandIdA | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 70 of file btMultiBodyJointMotor.cpp.

## ◆ getIslandIdB()

int btMultiBodyJointMotor::getIslandIdB | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 88 of file btMultiBodyJointMotor.cpp.

## ◆ setErp()

virtual void btMultiBodyJointMotor::setErp | ( | btScalar | erp | ) |
| inlinevirtual

Reimplemented from btMultiBodyConstraint.

Definition at line 59 of file btMultiBodyJointMotor.h.

## ◆ setPositionTarget()

virtual void btMultiBodyJointMotor::setPositionTarget | ( | btScalar | posTarget,
|  | btScalar | kp = 1.f )
| inlinevirtual

Definition at line 53 of file btMultiBodyJointMotor.h.

## ◆ setRhsClamp()

virtual void btMultiBodyJointMotor::setRhsClamp | ( | btScalar | rhsClamp | ) |
| inlinevirtual

Definition at line 67 of file btMultiBodyJointMotor.h.

## ◆ setVelocityTarget()

virtual void btMultiBodyJointMotor::setVelocityTarget | ( | btScalar | velTarget,
|  | btScalar | kd = 1.f )
| inlinevirtual

Definition at line 47 of file btMultiBodyJointMotor.h.

## Member Data Documentation

## ◆ m_desiredPosition

btScalar btMultiBodyJointMotor::m_desiredPosition
| protected

Definition at line 28 of file btMultiBodyJointMotor.h.

## ◆ m_desiredVelocity

btScalar btMultiBodyJointMotor::m_desiredVelocity
| protected

Definition at line 27 of file btMultiBodyJointMotor.h.

## ◆ m_erp

btScalar btMultiBodyJointMotor::m_erp
| protected

Definition at line 31 of file btMultiBodyJointMotor.h.

## ◆ m_kd

btScalar btMultiBodyJointMotor::m_kd
| protected

Definition at line 29 of file btMultiBodyJointMotor.h.

## ◆ m_kp

btScalar btMultiBodyJointMotor::m_kp
| protected

Definition at line 30 of file btMultiBodyJointMotor.h.

## ◆ m_rhsClamp

btScalar btMultiBodyJointMotor::m_rhsClamp
| protected

Definition at line 32 of file btMultiBodyJointMotor.h.

The documentation for this class was generated from the following files:

- btMultiBodyJointMotor.h
- btMultiBodyJointMotor.cpp